const type = "@@functional/placeholder";
const __ = {};
__[type] = true;
function is__(p) {
    return __ === p || (p && p[type]);
}
function find__(arr, len, start) {
    while (start < len) {
        if (is__(arr[start]))
            return start;
        start++;
    }
    return start;
}
function makeCurriedFunction(length, args, fn) {
    return function () {
        const combined = args.slice();
        let next = find__(combined, length, 0);
        const aLen = arguments.length;
        let adx = 0;
        while (next < length && adx < aLen) {
            if (!is__(arguments[adx])) {
                combined[next] = arguments[adx];
            }
            next = find__(combined, length, next + 1);
            adx++;
        }
        let idx = 0;
        let left = 0;
        while (idx < length) {
            if (is__(combined[idx++]))
                left++;
        }
        return left <= 0
            ? fn.apply(this, combined)
            : arity(left, makeCurriedFunction(length, combined, fn));
    };
}
function arity(n, fn) {
    switch (n) {
        case 0:
            return fn;
        /* eslint-disable @typescript-eslint/no-unused-vars */
        case 1:
            return function (a) {
                return fn.apply(this, arguments);
            };
        case 2:
            return function (a, b) {
                return fn.apply(this, arguments);
            };
        case 3:
            return function (a, b, c) {
                return fn.apply(this, arguments);
            };
        case 4:
            return function (a, b, c, d) {
                return fn.apply(this, arguments);
            };
        case 5:
            return function (a, b, c, d, e) {
                return fn.apply(this, arguments);
            };
        case 6:
            return function (a, b, c, d, e, f) {
                return fn.apply(this, arguments);
            };
        case 7:
            return function (a, b, c, d, e, f, g) {
                return fn.apply(this, arguments);
            };
        case 8:
            return function (a, b, c, d, e, f, g, h) {
                return fn.apply(this, arguments);
            };
        case 9:
            return function (a, b, c, d, e, f, g, h, i) {
                return fn.apply(this, arguments);
            };
        case 10:
            return function (a, b, c, d, e, f, g, h, i, j) {
                return fn.apply(this, arguments);
            };
        /* eslint-enable @typescript-eslint/no-unused-vars */
        default:
            throw new Error("curry only supports functions up to length 10");
    }
}
function curry(fn) {
    return curryN(fn.length, fn);
}
function curryN(len, fn) {
    let i = 0;
    const args = Array(len);
    while (i < len) {
        args[i++] = __;
    }
    return arity(len, makeCurriedFunction(len, args, fn));
}
export { __, curry, curryN };
